property pRoomObject, pMaxBallcount

on construct me
pMaxBallcount = getIntVariable("snowwar.object_snowball_machine.maximum_ballcount", 5)
return(1)
end

on deconstruct me
tWorld = me.getGameSystem().getWorld()
if tWorld <> 0 then -- jump 17
tWorld.clearObjectFromTileSpace(me.getObjectId())
end if -- jump 17 landing
me.removeRoomObject()
return(1)
end

on define me, tdata
tTileLoc = me.getGameSystem().convertworldtotilecoordinate(tdata[#objectDataStruct][#x], tdata[#objectDataStruct][#y])
if tTileLoc  = 0 then -- jump 31
return(error(me, "Invalid location, tile not found!" & RETURN & tdata[#objectDataStruct], #createRoomObject))
end if -- jump 31 landing
tdata.setaProp(#tile_x, tTileLoc[#x])
tdata.setaProp(#tile_y, tTileLoc[#y])
me.setGameObjectProperty(#tile_x, tTileLoc[#x])
me.setGameObjectProperty(#tile_y, tTileLoc[#y])
me.reserveSpaceForObject()
return(me.createRoomObject(tdata))
end

on executeGameObjectEvent me, tEvent, tdata
 --PEEKFROMSTACK 0 if tEvent  = #add_snowball then -- jump 39
if me.setBallCount(me.getBallCount() + 1) then -- jump 16
 --TRIMFROMSTACK 1 
return(me.renderBallCreation())
end if -- jump 16 landing
 -- jump 45
end if -- jump 39 landing
 --PEEKFROMSTACK 0 
--nil--  = #remove_snowball
if --nil-- then -- jump 36
if me.setBallCount(me.getBallCount() - 1) then -- jump 16
 --TRIMFROMSTACK 1 
return(me.renderBallCount())
end if -- jump 16 landing
end if -- jump 36 landing
end if -- jump 45 landing
 --TRIMFROMSTACK 1 
return(0)
end

on getBallCount me
return(me.getProp(#pGameObjectSyncValues, #snowball_count))
end

on setBallCount me, tValue
if tValue < 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tValue > pMaxBallcount then -- jump 8
return(0)
end if -- jump 8 landing
return(me.setGameObjectSyncProperty(#snowball_count, tValue))
end

on renderBallCreation me
if pRoomObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(pRoomObject.animate(me.getBallCount()))
end

on renderBallCount me
if pRoomObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(pRoomObject.render(me.getBallCount()))
end

on createRoomObject me, tDataStruct
pRoomObject = createObject(#temp, getClassVariable("snowwar.object_snowball_machine.roomobject.wrapper.class"))
if pRoomObject  = 0 then -- jump 18
return(error(me, "Cannot create roomobject wrapper for human!", #createRoomObject))
end if -- jump 18 landing
pRoomObject.define(tDataStruct)
pRoomObject.render(me.getBallCount())
return(1)
end

on removeRoomObject me
if objectp(pRoomObject) then -- jump 10
pRoomObject.deconstruct()
end if -- jump 10 landing
pRoomObject = 0
return(1)
end

on reserveSpaceForObject me
tWorld = me.getGameSystem().getWorld()
if tWorld  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tWorld.clearObjectFromTileSpace(me.getObjectId())
if not tWorld.reserveTileForObject(me.getGameObjectProperty(#tile_x), me.getGameObjectProperty(#tile_y), me.getObjectId(), me.getGameObjectProperty(#gameobject_height)) then -- jump 24
return(error(me, "Unable to reserve tile for snowballmachine in:" && me.pGameObjectSyncValues, #reserveSpaceForObject))
end if -- jump 24 landing
return(1)
end
