property pObjectId

on construct me
return(1)
end

on deconstruct me
me.removeRoomObject()
return(1)
end

on define me, tdata
return(me.createRoomObject(tdata))
end

on render me, tValue
if me.getRoomObject()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(me.getRoomObject().setFrame(tValue))
end

on animate me, tValue
if me.getRoomObject()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
me.getRoomObject().animate()
me.delay(1000, #render, tValue)
return(1)
end

on createRoomObject me, tdata
tdata[#id] = "sbm_" & tdata[#id]
pObjectId = tdata[#id]
tdata[#class] = "snowball_machine"
tdata[#direction] = [0, 0]
tdata[#altitude] = 0.0
tdata[#dimensions] = [0, 0]
tdata[#x] = tdata[#tile_x]
tdata[#y] = tdata[#tile_y]
tRoomComponent = getObject(#room_component)
if tRoomComponent  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tClassContainer = tRoomComponent.getClassContainer()
if tClassContainer  = 0 then -- jump 18
return(error(me, "Room class container not found!", #createRoomObject))
end if -- jump 18 landing
tClassContainer.set(tdata["class"], getClassVariable("snowwar.object_snowball_machine.roomobject.class"))
return(tRoomComponent.validateActiveObjects(tdata))
end

on getRoomObject me
tRoomComponentObj = getObject(#room_component)
if tRoomComponentObj  = 0 then -- jump 18
return(error(me, "Room component unavailable!", #getRoomObject))
end if -- jump 18 landing
return(tRoomComponentObj.getActiveObject(pObjectId))
end

on removeRoomObject me
tRoomComponentObj = getObject(#room_component)
if tRoomComponentObj  = 0 then -- jump 18
return(error(me, "Room component unavailable!", #removeRoomObject))
end if -- jump 18 landing
if pObjectId  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if not tRoomComponentObj.activeObjectExists(pObjectId) then -- jump 9
return(1)
end if -- jump 9 landing
return(tRoomComponentObj.removeActiveObject(pObjectId))
end
