property pRoomIndex

on construct me
return(1)
end

on deconstruct me
me.removeRoomObject()
pRoomComponentObj = void()
if not getObject(#session).exists("user_index") then -- jump 9
return(1)
end if -- jump 9 landing
if pRoomIndex  = getObject(#session).GET("user_index") then -- jump 57
if getObject(#session).exists("user_index") then -- jump 15
getObject(#session).Remove("user_index")
end if -- jump 15 landing
if getObject(#session).exists("user_game_index") then -- jump 15
getObject(#session).Remove("user_game_index")
end if -- jump 15 landing
end if -- jump 57 landing
return(1)
end

on define me, tdata
if tdata[#room_index] < 0 then -- jump 20
return(error(me, "Invalid room index for avatar:" && tdata, #define))
end if -- jump 20 landing
pRoomIndex = string(tdata[#room_index])
if tdata[#name]  = getObject(#session).GET(#userName) then -- jump 38
getObject(#session).set("user_index", pRoomIndex)
getObject(#session).set("user_game_index", tdata[#id])
end if -- jump 38 landing
return(me.createRoomObject(tdata))
end

on gameObjectMoveDone me, tX, tY, tH, tDirHead, tDirBody, tAction
tUserObject = me.getRoomObject()
if tUserObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tUserObject.gameObjectMoveDone(tX, tY, tH, tDirHead, tDirBody, tAction))
end

on gameObjectAction me, tAction, tdata
tUserObject = me.getRoomObject()
if tUserObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tUserObject.gameObjectAction(tAction, tdata))
end

on gameObjectRefreshLocation me, tX, tY, tH, tDirHead, tDirBody
tUserObject = me.getRoomObject()
if tUserObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tUserObject.resetValues(tX, tY, tH, tDirHead, tDirBody))
end

on gameObjectNewMoveTarget me, tX, tY, tH, tDirHead, tDirBody, tAction
tUserObject = me.getRoomObject()
if tUserObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tUserObject.gameObjectNewMoveTarget(tX, tY, tH, tDirHead, tDirBody, tAction))
end

on getPicture me
tUserObject = me.getRoomObject()
if tUserObject  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tUserObject.getPicture())
end

on getRoomObject me
tRoomComponentObj = getObject(#room_component)
if tRoomComponentObj  = 0 then -- jump 18
return(error(me, "Room component unavailable!", #getRoomObject))
end if -- jump 18 landing
return(tRoomComponentObj.getUserObject(pRoomIndex))
end

on createRoomObject me, tdata
tRoomComponentObj = getObject(#room_component)
if tRoomComponentObj  = 0 then -- jump 18
return(error(me, "Room component unavailable!", #createRoomObject))
end if -- jump 18 landing
tFigureSystemObj = getObject("Figure_System")
if tFigureSystemObj  = 0 then -- jump 18
return(error(me, "Figure system unavailable!", #createRoomObject))
end if -- jump 18 landing
tAvatarStruct = tdata.duplicate()
tAvatarStruct[#id] = pRoomIndex
tAvatarStruct.setaProp(#direction, [tdata[#dirBody], tdata[#dirBody]])
tClassID = "snowwar.object_avatar.roomobject.class"
tPlayerClass = getVariable(tClassID)
tClassContainer = tRoomComponentObj.getClassContainer()
if tClassContainer  = 0 then -- jump 18
return(error(me, "Avatar manager failed to initialize", #createRoomObject))
end if -- jump 18 landing
tClassContainer.set(tClassID, tPlayerClass)
tAvatarStruct.setaProp(#class, tClassID)
tAvatarStruct.setaProp(#x, tdata[#next_tile_x])
tAvatarStruct.setaProp(#y, tdata[#next_tile_y])
if tdata[#next_tile_z]  = void() then -- jump 21
tAvatarStruct.setaProp(#h, 0.0)
 -- jump 22
end if -- jump 21 landing
tAvatarStruct.setaProp(#h, tdata[#next_tile_z])
end if -- jump 22 landing
if tdata[#figure]  = EMPTY then -- jump 18
return(error(me, "Figure not found in human data, server probably didn't send it in GAMERESET (249)", #createRoomObject))
end if -- jump 18 landing
tAvatarStruct.setaProp(#custom, tdata[#mission])
tFigure = tFigureSystemObj.parseFigure(tdata[#figure], tdata[#sex], "user")
tAvatarStruct.setaProp(#figure, tFigure)
if not tRoomComponentObj.validateUserObjects(tAvatarStruct) then -- jump 21
return(error(me, "Room couldn't create avatar!", #createRoomObject))
 -- jump 9
end if -- jump 21 landing
return(1)
end if -- jump 9 landing
end

on removeRoomObject me
tRoomComponentObj = getObject(#room_component)
if tRoomComponentObj  = 0 then -- jump 18
return(error(me, "Room component unavailable!", #removeRoomObject))
end if -- jump 18 landing
if pRoomIndex  = void() then -- jump 8
return(0)
end if -- jump 8 landing
if not tRoomComponentObj.userObjectExists(pRoomIndex) then -- jump 9
return(1)
end if -- jump 9 landing
return(tRoomComponentObj.removeUserObject(pRoomIndex))
end
