property pTeamCount, pTeamScoreCache, pOwnScoreWindowId, pTeamScoreWindowId, pTimeWindowId, pTimeOutID, pBuffer, pTimerEndTime, pTimerDurationSec, pCountdownObjId

on construct me
pTeamScoreCache = []
pCountdownObjId = "game_countdown"
pFinalScoresObjId = "game_finalscores"
pOwnScoreWindowId = "game_win_own_score"
pTeamScoreWindowId = "game_win_team_score"
pTimeWindowId = "game_win_time"
pTimeOutID = "game_score_updateGameTimeout"
return(1)
end

on deconstruct me
me.removeGameScoreWindows()
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #set_number_of_teams then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setTeamNumber(tdata))
 -- jump 262
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #team_score_updated
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.updateTeamScores(tdata))
 -- jump 235
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #personal_score_updated
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.renderPersonalScores(tdata))
 -- jump 208
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = #update_game_visuals
if --nil-- then -- jump 35
me.cacheTeamScores()
me.renderPersonalScores(me.getOwnScore())
 --TRIMFROMSTACK 1 
return(1)
 -- jump 167
end if -- jump 35 landing
 --PEEKFROMSTACK 0 
--nil--  = #gamestart
if --nil-- then -- jump 53
me.startGameTimer(tdata[#time_until_game_end], tdata[#time_until_game_end], tdata[#time_until_game_end])
 --TRIMFROMSTACK 1 
return(me.showGameScoreWindows())
 -- jump 108
end if -- jump 53 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameend
if --nil-- then -- jump 19
 --TRIMFROMSTACK 1 
return(me.removeGameScoreWindows())
 -- jump 83
end if -- jump 19 landing
 --PEEKFROMSTACK 0 
--nil--  = #fullgamestatus_time
if --nil-- then -- jump 74
if tdata[#state] <> #started then -- jump 11
 --TRIMFROMSTACK 1 
return(1)
end if -- jump 11 landing
me.startGameTimer(tdata[#time_to_next_state], tdata[#state_duration], tdata[#time_until_game_end])
 --TRIMFROMSTACK 1 
return(me.showGameScoreWindows())
end if -- jump 74 landing
end if -- jump 83 landing
end if -- jump 108 landing
end if -- jump 167 landing
end if -- jump 208 landing
end if -- jump 235 landing
end if -- jump 262 landing
 --TRIMFROMSTACK 1 
return(1)
end

on setTeamNumber me, tTeamNum
pTeamCount = tTeamNum
pTeamScoreCache = []
pTeamScoreCache[pTeamCount] = 0
return(1)
end

on getOwnScore me
if not getObject(#session).exists("user_game_index") then -- jump 8
return(0)
end if -- jump 8 landing
tObjectID = getObject(#session).GET("user_game_index")
tScore = me.getGameSystem().getGameObjectProperty(tObjectID, #score)
return(tScore)
end

on startGameTimer me, tTimeUntilNextState, tStateDuration, tTimeUntilGameEnd
if tTimeUntilNextState <= 0 then -- jump 8
return(0)
end if -- jump 8 landing
pTimerEndTime = the milliSeconds + tTimeUntilNextState * 1000
pTimerDurationSec = tStateDuration
if timeoutExists(pTimeOutID) then -- jump 11
removeTimeout(pTimeOutID)
end if -- jump 11 landing
createTimeout(pTimeOutID, 1000, #renderGameTimer, me.getID(), pTimerEndTime, tTimeUntilGameEnd)
return(me.renderGameTimer(pTimerEndTime))
end

on convertToMinSec me, tTime
tMin = tTime / 60000
tSec = tTime mod 60000 / 1000
if tSec < 10 then -- jump 10
tSec = "0" & tSec
end if -- jump 10 landing
return([tMin, tSec])
end

on renderGameTimer me, tEndTime
tWndObj = getWindow(pTimeWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("snowwar_sd_timeleft")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tEndTime < the milliSeconds then -- jump 8
return(0)
end if -- jump 8 landing
tTime = me.convertToMinSec(tEndTime - the milliSeconds)
tTimeStr = tTime[1] & ":" & tTime[2]
tElem.setText(tTimeStr)
tElem = tWndObj.getElement("snowwar_timeleft")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem.setText(tTimeStr)
return(1)
end

on renderPersonalScores me, tdata
tWndObj = getWindow(pOwnScoreWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if not integerp(tdata) then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("snowwar_score_sd_self")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem.setText(tdata)
tElem = tWndObj.getElement("snowwar_score_self")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem.setText(tdata)
return(1)
end

on cacheTeamScores me
if pTeamCount < 1 then -- jump 18
return(error(me, "Team count has not been set!", #cacheTeamScores))
end if -- jump 18 landing
pTeamScoreCache = []
pTeamScoreCache[pTeamCount] = 0
tGameSystem = me.getGameSystem()
tIDList = tGameSystem.getGameObjectIdsOfType("avatar")
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tIDList) <= 1 then -- jump 80 -- backjump 83 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tID = --nil--
tObject = tGameSystem.getGameObject(tID)
if tObject <> 0 then -- jump 47
tTeamId = tObject.getGameObjectProperty("team_id") + 1
tScore = tObject.getGameObjectProperty("score")
pTeamScoreCache[tTeamId] = pTeamScoreCache[tTeamId] + tScore
end if -- jump 47 landing
--nil-- + 1
 -- backjump 83
end if -- jump 80 landing
 --TRIMFROMSTACK 3 
return(me.renderTeamScores())
end

on updateTeamScores me, tdata
if not listp(tdata) then -- jump 8
return(0)
end if -- jump 8 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tdata) <= 1 then -- jump 80 -- backjump 83 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tTeam = --nil--
tTeamId = tTeam[#team_id] + 1
if pTeamScoreCache.count < tTeamId then -- jump 13
pTeamScoreCache[tTeamId] = 0
end if -- jump 13 landing
pTeamScoreCache[tTeamId] = pTeamScoreCache[tTeamId] + tTeam[#score_add]
--nil-- + 1
 -- backjump 83
end if -- jump 80 landing
 --TRIMFROMSTACK 3 
return(me.renderTeamScores())
end

on renderTeamScores me
tWndObj = getWindow(pTeamScoreWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if not listp(pTeamScoreCache) then -- jump 8
return(0)
end if -- jump 8 landing
tTeamId = 1
if tTeamId <= pTeamScoreCache.count then -- jump 89 -- backjump 95 landing
tTeamScore = string(pTeamScoreCache[tTeamId])
tElem = tWndObj.getElement("snowwar_score_sd_team" & tTeamId)
if tElem <> 0 then -- jump 44
if tTeamScore <> tElem.getText() then -- jump 31
tElem.setText(tTeamScore)
tWndObj.getElement("snowwar_score_team" & tTeamId).setText(tTeamScore)
end if -- jump 31 landing
end if -- jump 44 landing
tTeamId = 1 + tTeamId
 -- backjump 95
end if -- jump 89 landing
return(1)
end

on showGameScoreWindows me
if not windowExists(pTeamScoreWindowId) then -- jump 154
if createWindow(pTeamScoreWindowId, "team_stats.window") then -- jump 126
tWndObj = getWindow(pTeamScoreWindowId)
tLocH = the stage.rect.width - 54
if me.getGameSystem().getSpectatorModeFlag() then -- jump 20
tWndObj.moveTo(tLocH - 30, 40)
 -- jump 14
end if -- jump 20 landing
tWndObj.moveTo(tLocH, 70)
end if -- jump 14 landing
tWndObj.lock()
tTeamId = 1
if tTeamId <= 4 then -- jump 34 -- backjump 37 landing
me.setTeamScoreVisible(tTeamId, tTeamId <= pTeamCount and pTeamCount > 1)
tTeamId = 1 + tTeamId
 -- backjump 37
end if -- jump 34 landing
me.renderTeamScores()
 -- jump 18
end if -- jump 126 landing
return(error(me, "Cannot open team score window.", #showGameScoreWindows))
end if -- jump 18 landing
end if -- jump 154 landing
if not windowExists(pOwnScoreWindowId) and not me.getGameSystem().getSpectatorModeFlag() then -- jump 88
if createWindow(pOwnScoreWindowId, "personal_stats.window") then -- jump 60
tWndObj = getWindow(pOwnScoreWindowId)
tLocH = the stage.rect.width - 54
tWndObj.moveTo(tLocH, 10)
tWndObj.lock()
me.renderPersonalScores(me.getOwnScore())
 -- jump 18
end if -- jump 60 landing
return(error(me, "Cannot open personal score window.", #showGameScoreWindows))
end if -- jump 18 landing
end if -- jump 88 landing
if not windowExists(pTimeWindowId) then -- jump 98
if createWindow(pTimeWindowId, "habbo_simple.window") then -- jump 70
tWndObj = getWindow(pTimeWindowId)
tWndObj.merge("sw_timeleft.window")
if me.getGameSystem().getSpectatorModeFlag() then -- jump 17
tWndObj.moveTo(26, 36)
 -- jump 14
end if -- jump 17 landing
tWndObj.moveTo(10, 15)
end if -- jump 14 landing
tWndObj.lock()
 -- jump 18
end if -- jump 70 landing
return(error(me, "Cannot open timeleft window.", #showGameScoreWindows))
end if -- jump 18 landing
end if -- jump 98 landing
return(1)
end

on setTeamScoreVisible me, tTeamId, tstate
tWndObj = getWindow(pTeamScoreWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElement = tWndObj.getElement("snowwar_scorebg_team" & tTeamId)
if tElement <> 0 then -- jump 14
tElement.setProperty(#visible, tstate)
end if -- jump 14 landing
tElement = tWndObj.getElement("snowwar_score_sd_team" & tTeamId)
if tElement <> 0 then -- jump 14
tElement.setProperty(#visible, tstate)
end if -- jump 14 landing
tElement = tWndObj.getElement("snowwar_score_team" & tTeamId)
if tElement <> 0 then -- jump 14
tElement.setProperty(#visible, tstate)
end if -- jump 14 landing
return(1)
end

on removeGameScoreWindows me
if windowExists(pTeamScoreWindowId) then -- jump 11
removeWindow(pTeamScoreWindowId)
end if -- jump 11 landing
if windowExists(pOwnScoreWindowId) then -- jump 11
removeWindow(pOwnScoreWindowId)
end if -- jump 11 landing
if windowExists(pTimeWindowId) then -- jump 11
removeWindow(pTimeWindowId)
end if -- jump 11 landing
if timeoutExists(pTimeOutID) then -- jump 11
removeTimeout(pTimeOutID)
end if -- jump 11 landing
return(1)
end
