property pSpriteOwnerId, pSprite, pSpriteSd, pConstants, pVelocityTable

on deconstruct me
pVelocityTable = void()
pConstants = void()
me.resetTargets()
me.removeSprites()
return(1)
end

on define me, tdata
me.SetConstants()
tGameSystem = getObject(#snowwar_gamesystem)
pVelocityTable = tGameSystem.GetVelocityTable()
pSpriteOwnerId = tGameSystem.getID() & "_snowball_" & me.getID()
me.setGameObjectProperty(#gameobject_collisionshape_type, getVariable("snowwar.object_snowball.collisionshape_type"))
me.setGameObjectProperty(#gameobject_collisionshape_radius, getVariable("snowwar.object_snowball.collisionshape_radius"))
me.createSprites(tdata[#x], tdata[#y], tdata[#z])
return(1)
end

on calculateFlightPath me, tdata, tTargetX, tTargetY
me.SetConstants()
tGameSystem = me.getGameSystem()
pVelocityTable = tGameSystem.GetVelocityTable()
tX = tdata.x
tY = tdata.y
me.setProp(#pGameObjectSyncValues, #trajectory, tdata[#trajectory])
tDeltaX = tTargetX - tX / 200
tDeltaY = tTargetY - tY / 200
me.setProp(#pGameObjectSyncValues, #movement_direction, tGameSystem.get360AngleFromComponents(tDeltaX, tDeltaY))
if tdata[#trajectory]  = pConstants.TRAJECTORY_QUICK_THROW then -- jump 32
tZ = pConstants.QUICK_THROW_HEIGHT_LEVEL
me.setProp(#pGameObjectSyncValues, #time_to_live, pConstants.QUICK_THROW_TIME_TO_LIVE)
 -- jump 156
end if -- jump 32 landing
if tdata[#trajectory]  = pConstants.TRAJECTORY_SHORT_LOB then -- jump 59
tDistanceToTarget = tGameSystem.sqrt(tDeltaX * tDeltaX + tDeltaY * tDeltaY) * 200
tZ = pConstants.SHORT_LOB_HEIGHT_LEVEL
me.setProp(#pGameObjectSyncValues, #time_to_live, tDistanceToTarget / pConstants.SHORT_LOB_VELOCITY)
 -- jump 82
end if -- jump 59 landing
if tdata[#trajectory]  = pConstants.TRAJECTORY_LONG_LOB then -- jump 59
tDistanceToTarget = tGameSystem.sqrt(tDeltaX * tDeltaX + tDeltaY * tDeltaY) * 200
tZ = pConstants.LONG_LOB_HEIGHT_LEVEL
me.setProp(#pGameObjectSyncValues, #time_to_live, tDistanceToTarget / pConstants.LONG_LOB_VELOCITY)
 -- jump 8
end if -- jump 59 landing
return(0)
end if -- jump 8 landing
end if -- jump 82 landing
end if -- jump 156 landing
me.setProp(#pGameObjectSyncValues, #parabola_offset, me.getProp(#pGameObjectSyncValues, #time_to_live) / 2)
me.createSprites(tX, tY, tZ)
return(1)
end

on calculateFrameMovement me
if me.pKilled then -- jump 11
return(void())
end if -- jump 11 landing
tLocation3D = me.getLocation()
me.setProp(#pGameObjectSyncValues, #time_to_live, me.getProp(#pGameObjectSyncValues, #time_to_live) - 1)
if me.getProp(#pGameObjectSyncValues, #trajectory)  = pConstants.TRAJECTORY_QUICK_THROW then -- jump 200
tNewX = tLocation3D.x + pVelocityTable.GetBaseVelX(me.getProp(#pGameObjectSyncValues, #movement_direction)) * pConstants.QUICK_THROW_VELOCITY / 255
tNewY = tLocation3D.y + pVelocityTable.GetBaseVelY(me.getProp(#pGameObjectSyncValues, #movement_direction)) * pConstants.QUICK_THROW_VELOCITY / 255
if me.getProp(#pGameObjectSyncValues, #time_to_live) > pConstants.QUICK_THROW_DESCENT_POINT then -- jump 27
tTemp = pConstants.QUICK_THROW_DESCENT_POINT - me.getProp(#pGameObjectSyncValues, #parabola_offset)
 -- jump 30
end if -- jump 27 landing
tTemp = me.getProp(#pGameObjectSyncValues, #time_to_live) - me.getProp(#pGameObjectSyncValues, #parabola_offset)
end if -- jump 30 landing
tNewZ = me.getProp(#pGameObjectSyncValues, #parabola_offset) * me.getProp(#pGameObjectSyncValues, #parabola_offset) - tTemp * tTemp * 4 + pConstants.QUICK_THROW_HEIGHT_LEVEL
 -- jump 323
end if -- jump 200 landing
if me.getProp(#pGameObjectSyncValues, #trajectory)  = pConstants.TRAJECTORY_SHORT_LOB then -- jump 154
tNewX = tLocation3D.x + pVelocityTable.GetBaseVelX(me.getProp(#pGameObjectSyncValues, #movement_direction)) * pConstants.SHORT_LOB_VELOCITY / 255
tNewY = tLocation3D.y + pVelocityTable.GetBaseVelY(me.getProp(#pGameObjectSyncValues, #movement_direction)) * pConstants.SHORT_LOB_VELOCITY / 255
tTemp = me.getProp(#pGameObjectSyncValues, #time_to_live) - me.getProp(#pGameObjectSyncValues, #parabola_offset)
tNewZ = me.getProp(#pGameObjectSyncValues, #parabola_offset) * me.getProp(#pGameObjectSyncValues, #parabola_offset) - tTemp * tTemp * 10 + pConstants.SHORT_LOB_HEIGHT_LEVEL
 -- jump 151
end if -- jump 154 landing
tNewX = tLocation3D.x + pVelocityTable.GetBaseVelX(me.getProp(#pGameObjectSyncValues, #movement_direction)) * pConstants.LONG_LOB_VELOCITY / 255
tNewY = tLocation3D.y + pVelocityTable.GetBaseVelY(me.getProp(#pGameObjectSyncValues, #movement_direction)) * pConstants.LONG_LOB_VELOCITY / 255
tTemp = me.getProp(#pGameObjectSyncValues, #time_to_live) - me.getProp(#pGameObjectSyncValues, #parabola_offset)
tNewZ = me.getProp(#pGameObjectSyncValues, #parabola_offset) * me.getProp(#pGameObjectSyncValues, #parabola_offset) - tTemp * tTemp * 100 + pConstants.LONG_LOB_HEIGHT_LEVEL
end if -- jump 151 landing
end if -- jump 323 landing
me.setLocation(tNewX, tNewY, tNewZ)
me.setGameObjectSyncProperty([#x: tNewX, #y: tNewY, #z: tNewZ])
me.moveSprites(tNewX, tNewY, tNewZ)
tCollisionWithGroundObject = me.testCollisionWithGround()
if tNewZ < 1 or tCollisionWithGroundObject then -- jump 19
playSound("LS-miss")
return(me.Remove())
end if -- jump 19 landing
return(1)
end

on testCollisionWithGround me
tLocation3D = me.getLocation()
if tLocation3D.z < 1 then -- jump 9
return(1)
end if -- jump 9 landing
tTile = me.getGameSystem().gettileatworldcoordinate(tLocation3D.x, tLocation3D.y, tLocation3D.z)
if tTile  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tTile.getOccupiedHeight() > tLocation3D.z then -- jump 9
return(1)
end if -- jump 9 landing
return(0)
end

on moveSprites me, tNewX, tNewY, tNewZ
if ilk(pSprite) <> #sprite then -- jump 8
return(0)
end if -- jump 8 landing
tWorld = me.getGameSystem().getWorld()
tloc = tWorld.convertWorldToScreenCoordinate(tNewX, tNewY, tNewZ)
pSprite.loc = point(tloc[1], tloc[2])
pSprite.locZ = tloc[3]
tTile = tWorld.gettileatworldcoordinate(tNewX, tNewY, tNewZ)
if tTile  = 0 then -- jump 9
tGroundZ = 0
 -- jump 12
end if -- jump 9 landing
tGroundZ = tTile.getOccupiedHeight()
end if -- jump 12 landing
tloc = tWorld.convertWorldToScreenCoordinate(tNewX, tNewY, tGroundZ)
pSpriteSd.loc = point(tloc[1], tloc[2])
pSpriteSd.locZ = tloc[3]
return(1)
end

on createSprites me, tX, tY, tZ
me.removeSprites()
pSprite = sprite(reserveSprite(pSpriteOwnerId))
pSprite.member = member(getmemnum("snowball"))
pSpriteSd = sprite(reserveSprite(pSpriteOwnerId))
pSpriteSd.member = member(getmemnum("snowball_sd"))
return(me.moveSprites(tX, tY, tZ))
end

on removeSprites me
if ilk(pSprite)  = #sprite then -- jump 12
releaseSprite(pSprite.spriteNum)
end if -- jump 12 landing
if ilk(pSpriteSd)  = #sprite then -- jump 13
releaseSprite(pSpriteSd.spriteNum)
end if -- jump 13 landing
pSprite = void()
pSpriteSd = void()
return(1)
end

on SetConstants me
pConstants = [:]
pConstants[#TRAJECTORY_QUICK_THROW] = 0
pConstants[#TRAJECTORY_SHORT_LOB] = 1
pConstants[#TRAJECTORY_LONG_LOB] = 2
pConstants[#QUICK_THROW_DESCENT_POINT] = getIntVariable("QUICK_THROW_DESCENT_POINT")
pConstants[#QUICK_THROW_TIME_TO_LIVE] = getIntVariable("QUICK_THROW_TIME_TO_LIVE")
pConstants[#QUICK_THROW_VELOCITY] = getIntVariable("QUICK_THROW_VELOCITY")
pConstants[#SHORT_LOB_VELOCITY] = getIntVariable("SHORT_LOB_VELOCITY")
pConstants[#LONG_LOB_VELOCITY] = getIntVariable("LONG_LOB_VELOCITY")
pConstants[#QUICK_THROW_HEIGHT_LEVEL] = getIntVariable("QUICK_THROW_HEIGHT_LEVEL")
pConstants[#SHORT_LOB_HEIGHT_LEVEL] = getIntVariable("SHORT_LOB_HEIGHT_LEVEL")
pConstants[#LONG_LOB_HEIGHT_LEVEL] = getIntVariable("LONG_LOB_HEIGHT_LEVEL")
return(1)
end
