property pMainWindowId, pGoButtonImages, pJoinButtonImage, pWriterPlainNormLeft, pWriterListPlainNormLeft, pWriterPlainNormRight, pWriterPlainBoldLeft, pWriterLinkRight

on construct me
pMainWindowId = "GAME"
tPlainFontStruct = getStructVariable("struct.font.plain")
createWriter("gs_plain_norm_left", tPlainFontStruct)
pWriterPlainNormLeft = getWriter("gs_plain_norm_left")
pWriterPlainNormLeft.define([#wordWrap: 0, #fixedLineSpace: tPlainFontStruct[#lineHeight]])
createWriter("gs_list_plain_norm_left", tPlainFontStruct)
pWriterListPlainNormLeft = getWriter("gs_list_plain_norm_left")
pWriterListPlainNormLeft.define([#wordWrap: 0, #fixedLineSpace: 16])
createWriter("gs_plain_norm_right", tPlainFontStruct)
pWriterPlainNormRight = getWriter("gs_plain_norm_right")
pWriterPlainNormRight.setProperty(#alignment, #right)
pWriterPlainNormRight.define([#wordWrap: 0])
tBoldFontStruct = getStructVariable("struct.font.bold")
createWriter("gs_plain_bold_left", tBoldFontStruct)
pWriterPlainBoldLeft = getWriter("gs_plain_bold_left")
tStruct = getStructVariable("struct.font.link")
tStruct.setaProp(#fontStyle, [#underline])
tStruct.setaProp(#font, tBoldFontStruct[#font])
createWriter("gs_link_right", tStruct)
pWriterLinkRight = getWriter("gs_link_right")
me.renderButtonImages()
return(1)
end

on deconstruct me
removeWriter("gs_plain_norm_left")
pWriterPlainNormLeft = void()
removeWriter("gs_list_plain_norm_left")
pWriterListPlainNormLeft = void()
removeWriter("gs_plain_norm_right")
pWriterPlainNormRight = void()
removeWriter("gs_plain_bold_left")
pWriterPlainBoldLeft = void()
removeWriter("gs_link_right")
pWriterLinkRight = void()
pGoButtonImages = void()
pJoinButtonImage = void()
return(1)
end

on defineWindow me, tID
pMainWindowId = tID
return(1)
end

on renderButtonImages me
pGoButtonImages = [:]
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(["created", "started", "finished"]) <= 1 then -- jump 139 -- backjump 142 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tstate = --nil--
tButtonImage = image(92, 12, 8)
tImage = pWriterLinkRight.render(getText("gs_button_go_" & tstate))
tLocH = 80 - tImage.width
tButtonImage.copyPixels(tImage, tImage.rect + rect(tLocH, 0, tLocH, 0), tImage.rect)
tImage = member(getmemnum("sw_arr")).image
tButtonImage.copyPixels(tImage, tImage.rect + rect(84, 1, 84, 1), tImage.rect)
pGoButtonImages.addProp(tstate, tButtonImage)
--nil-- + 1
 -- backjump 142
end if -- jump 139 landing
 --TRIMFROMSTACK 3 
pJoinButtonImage = image(191, 16, 8)
tImage = pWriterLinkRight.render(getText("bb_link_join"))
tLocH = 176 - tImage.width
pJoinButtonImage.copyPixels(tImage, tImage.rect + rect(tLocH, 3, tLocH, 3), tImage.rect)
tImage = member(getmemnum("sw_arr")).image
pJoinButtonImage.copyPixels(tImage, tImage.rect + rect(180, 4, 180, 4), tImage.rect)
return(1)
end

on renderTournamentLogo me, tTournamentLogoMemNum
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tTournamentLogoMemNum  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_logo_tournament")
if tElem <> 0 then -- jump 51
tmember = member(tTournamentLogoMemNum)
if tmember.type  = #bitmap and tElem <> 0 then -- jump 28
tElem.setProperty(#cursor, "cursor.finger")
tElem.setProperty(#image, tmember.image)
end if -- jump 28 landing
end if -- jump 51 landing
return(1)
end

on renderInstanceList me, tList, tStartIndex, tCount
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
i = 1
if i <= tCount then -- jump 476 -- backjump 478 landing
tIndex = tStartIndex + i - 1
tElem = tWndObj.getElement("gs_area_gameList" & i)
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tIndex <= tList.count then -- jump 348
tItem = tList[tIndex]
tImage = me.getInstanceListItemBg(tItem[#state])
tTextImg = pWriterPlainBoldLeft.render(tItem[#name])
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 3, 32, 3), tTextImg.rect)
tTextImg = pWriterPlainNormRight.render(me.convertSecToMinSec(tItem[#gameLength]))
tLocH = tImage.width - tTextImg.width - 3
tImage.copyPixels(tTextImg, tTextImg.rect + rect(tLocH, 3, tLocH, 3), tTextImg.rect)
tTextImg = pWriterPlainNormLeft.render(tItem[#host][#name])
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 15, 32, 15), tTextImg.rect)
tTextImg = pWriterPlainNormLeft.render(getText("sw_fieldname_" & tItem[#fieldType]))
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 28, 32, 28), tTextImg.rect)
tGoButtonImage = pGoButtonImages[tItem[#state]]
if tGoButtonImage <> void() then -- jump 53
tLocH = tImage.width - tGoButtonImage.width - 5
tImage.copyPixels(tGoButtonImage, tGoButtonImage.rect + rect(tLocH, 26, tLocH, 26), tGoButtonImage.rect, [#ink: 36])
end if -- jump 53 landing
tElem.setProperty(#cursor, "cursor.finger")
 -- jump 66
end if -- jump 348 landing
tImage = me.getInstanceListItemBg(#empty)
tTextImg = pWriterPlainNormLeft.render("---")
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 24, 32, 24), tTextImg.rect)
tElem.setProperty(#cursor, 0)
end if -- jump 66 landing
tElem.feedImage(tImage)
i = 1 + i
 -- backjump 478
end if -- jump 476 landing
return(1)
end

on getInstanceListItemBg me, tstate
 --PEEKFROMSTACK 0 if tstate  = #created then -- jump 48
tImage1 = member(getmemnum("sw_bg_grn4")).image
tImage2 = member(getmemnum("sw_ico_thumb")).image
tRegPoint2 = member(getmemnum("sw_ico_thumb")).regPoint
 -- jump 134
end if -- jump 48 landing
 --PEEKFROMSTACK 0 
--nil--  = #started
if --nil-- then -- jump 48
tImage1 = member(getmemnum("sw_bg_red4")).image
tImage2 = member(getmemnum("sw_ico_bounce")).image
tRegPoint2 = member(getmemnum("sw_ico_bounce")).regPoint
 -- jump 80
end if -- jump 48 landing
 --PEEKFROMSTACK 0 
--nil--  = #finished
if --nil-- then -- jump 48
tImage1 = member(getmemnum("sw_bg_gry4")).image
tImage2 = member(getmemnum("sw_ico_flag")).image
tRegPoint2 = member(getmemnum("sw_ico_flag")).regPoint
 -- jump 26
end if -- jump 48 landing
 --PEEKFROMSTACK 0 
--nil--  = #empty
if --nil-- then -- jump 17
tImage1 = member(getmemnum("sw_bg_emp3")).image
end if -- jump 17 landing
end if -- jump 26 landing
end if -- jump 80 landing
end if -- jump 134 landing
 --TRIMFROMSTACK 1 
tImage = image(191, 40, 8, member(getmemnum("snow_war2 Palette")))
tImage.copyPixels(tImage1, tImage.rect, tImage1.rect)
if tImage2 <> void() then -- jump 69
tImage.copyPixels(tImage2, tImage2.rect + rect(3 - tRegPoint2.locH, 7 - tRegPoint2.locV, 3 - tRegPoint2.locH, 7 - tRegPoint2.locV), tImage2.rect, [#ink: 8, #maskImage: tImage2.createMatte()])
end if -- jump 69 landing
return(tImage)
end

on renderInstanceDetailTop me, tName, tHostName, tstate, tStateStr, tSpecs
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_header_gameChsn")
if tElem <> 0 then -- jump 12
tElem.setText(tName)
end if -- jump 12 landing
tImage = image(191, 48, 8, member(getmemnum("snow_war2 Palette")))
 --PEEKFROMSTACK 0 if tstate  = #created then -- jump 30
tStateIconMember = member(getmemnum("sw_ico_thumb"))
tBgImageMember = member(getmemnum("sw_gameinfo_bg_1"))
 -- jump 72
end if -- jump 30 landing
 --PEEKFROMSTACK 0 
--nil--  = #started
if --nil-- then -- jump 30
tStateIconMember = member(getmemnum("sw_ico_bounce"))
tBgImageMember = member(getmemnum("sw_gameinfo_bg_1"))
 -- jump 36
end if -- jump 30 landing
 --PEEKFROMSTACK 0 
--nil--  = #finished
if --nil-- then -- jump 27
tStateIconMember = member(getmemnum("sw_ico_flag"))
tBgImageMember = member(getmemnum("sw_gameinfo_bg_1"))
end if -- jump 27 landing
end if -- jump 36 landing
end if -- jump 72 landing
 --TRIMFROMSTACK 1 
if tBgImageMember  = member(0) then -- jump 8
return(0)
end if -- jump 8 landing
tBgImage = tBgImageMember.image
tImage.copyPixels(tBgImage, tImage.rect, tBgImage.rect)
tAddOffset = 0
tTextImg = pWriterPlainNormLeft.render(tHostName)
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 4 + tAddOffset, 32, 4 + tAddOffset), tTextImg.rect)
tTextImg = pWriterPlainNormLeft.render(tStateStr)
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 20 + tAddOffset, 32, 20 + tAddOffset), tTextImg.rect)
tTextImg = pWriterPlainNormLeft.render(tSpecs)
tImage.copyPixels(tTextImg, tTextImg.rect + rect(32, 36 + tAddOffset, 32, 36 + tAddOffset), tTextImg.rect)
if tStateIconMember  = void() then -- jump 8
return(0)
end if -- jump 8 landing
tStateIcon = tStateIconMember.image
tStRegpoint = tStateIconMember.regPoint
tImage.copyPixels(tStateIcon, tStateIcon.rect + rect(3 - tStRegpoint.locH, 13 - tStRegpoint.locV, 3 - tStRegpoint.locH, 13 - tStRegpoint.locV), tStateIcon.rect, [#ink: 8, #maskImage: tStateIcon.createMatte()])
tElem = tWndObj.getElement("gs_area_gameInfo")
if tElem <> 0 then -- jump 12
tElem.feedImage(tImage)
end if -- jump 12 landing
return(1)
end

on renderInstanceDetailButton me, tButtonState, tGameState
tResult = image(191, 16, 8)
tBlend = 255
 --PEEKFROMSTACK 0 if tButtonState <> #start then -- jump 12
 --PEEKFROMSTACK 0 
--nil--  = #start_dimmed
if --nil-- then -- jump 47
end if -- jump 12 landing
tBg = member(getmemnum("sw_lnk_px_1")).image
tText = getText("gs_button_start")
if tButtonState  = #start_dimmed then -- jump 12
tBlend = 50
tButtonState = #start
end if -- jump 12 landing
 -- jump 77
end if -- jump 47 landing
 --PEEKFROMSTACK 0 
--nil--  = #spectate
if --nil-- then -- jump 29
tBg = member(getmemnum("sw_bg_px")).image
tText = getText("gs_button_spectate")
 -- jump 42
end if -- jump 29 landing
 --PEEKFROMSTACK 0 
--nil--  = #spectateInfo
if --nil-- then -- jump 29
tBg = member(getmemnum("sw_bg_px")).image
tText = getText("gs_text_spectate")
 -- jump 7
end if -- jump 29 landing
tText = EMPTY
end if -- jump 7 landing
end if -- jump 42 landing
end if -- jump 77 landing
 --TRIMFROMSTACK 1 
if ilk(tBg) <> #image then -- jump 8
return(0)
end if -- jump 8 landing
tResult.paletteRef = tBg.paletteRef
tResult.copyPixels(tBg, tResult.rect, tBg.rect)
tWidth = tResult.width
if tButtonState  = #start or tButtonState  = #spectate then -- jump 133
tImage = pWriterLinkRight.render(tText)
tLocH = tWidth - tImage.width - 10
tResult.copyPixels(tImage, tImage.rect + rect(tLocH - 5, 3, tLocH - 5, 3), tImage.rect, [#blendLevel: tBlend])
tImage = member(getmemnum("sw_arr")).image
tResult.copyPixels(tImage, tImage.rect + rect(tWidth - 12, 4, tWidth - 12, 4), tImage.rect, [#ink: 36, #blendLevel: tBlend])
 -- jump 67
end if -- jump 133 landing
if tText <> #empty then -- jump 58
tImage = pWriterPlainBoldLeft.render(tText)
tLocH = tWidth / 2 - tImage.width / 2
tResult.copyPixels(tImage, tImage.rect + rect(tLocH, 3, tLocH, 3), tImage.rect)
end if -- jump 58 landing
end if -- jump 67 landing
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_link_gameInfo")
tElem.feedImage(tResult)
 --PEEKFROMSTACK 0 if tButtonState <> #empty then -- jump 12
 --PEEKFROMSTACK 0 
--nil--  = #spectateInfo
if --nil-- then -- jump 17
end if -- jump 12 landing
tElem.setProperty(#cursor, 0)
 -- jump 15
end if -- jump 17 landing
tElem.setProperty(#cursor, "cursor.finger")
end if -- jump 15 landing
 --TRIMFROMSTACK 1 
end

on renderInstanceDetailTeams me, tParams, tUserName, tHost, tOwnTeam
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tTeamNum = 1
if tTeamNum <= tParams[#numTeams] then -- jump 675 -- backjump 684 landing
tImage = tWndObj.getElement("gs_area_team" & tTeamNum).getProperty(#buffer)
if tImage.type <> #bitmap then -- jump 8
return(0)
end if -- jump 8 landing
tImage = tImage.image
tBallImage = member(getmemnum("sw_ico_team" & tParams[#teams][tTeamNum][#id])).image
if tBallImage <> void() then -- jump 32
tImage.copyPixels(tBallImage, tBallImage.rect + rect(5, 6, 5, 6), tBallImage.rect)
end if -- jump 32 landing
tText = EMPTY
tPlayers = tParams[#teams][tTeamNum][#players]
tPlayerNum = 1
if tPlayerNum <= tPlayers.count then -- jump 110 -- backjump 115 landing
tText = tText & tPlayers[tPlayerNum][#name] & RETURN
tElem = tWndObj.getElement("bb_kick" & tTeamNum & "_" & tPlayerNum)
tNotMe = tPlayers[tPlayerNum][#name] <> tUserName
if tElem <> 0 then -- jump 31
tElem.setProperty(#visible, tHost and tParams[#state]  = #created and tNotMe)
end if -- jump 31 landing
tPlayerNum = 1 + tPlayerNum
 -- backjump 115
end if -- jump 110 landing
tPlayerNum = tPlayers.count + 1
if tPlayerNum <= 12 then -- jump 49 -- backjump 52 landing
tElem = tWndObj.getElement("bb_kick" & tTeamNum & "_" & tPlayerNum)
if tElem <> 0 then -- jump 13
tElem.setProperty(#visible, 0)
end if -- jump 13 landing
tPlayerNum = 1 + tPlayerNum
 -- backjump 52
end if -- jump 49 landing
tAddedOffset = 0
tTextImg = pWriterListPlainNormLeft.render(tText)
tImage.copyPixels(tTextImg, tTextImg.rect + rect(30, -3 + tAddedOffset, 30, -3 + tAddedOffset), tTextImg.rect)
if tParams[#state]  = #finished then -- jump 268
tText = EMPTY
tPlayerNum = 1
if tPlayerNum <= tPlayers.count then -- jump 35 -- backjump 40 landing
tText = tText & tPlayers[tPlayerNum][#score] & RETURN
tPlayerNum = 1 + tPlayerNum
 -- backjump 40
end if -- jump 35 landing
pWriterPlainNormRight.define([#fixedLineSpace: 16])
tTextImg = pWriterPlainNormRight.render(tText)
tOffsetH = 158
tImage.copyPixels(tTextImg, tTextImg.rect + rect(tOffsetH, -3 + tAddedOffset, tOffsetH, -3 + tAddedOffset), tTextImg.rect)
tTextImg = pWriterListPlainNormLeft.render(getText("gs_scores_team_" & tParams[#teams][tTeamNum][#id]))
tOffsetV = tImage.height - 18
tImage.copyPixels(tTextImg, tTextImg.rect + rect(30, tOffsetV, 30, tOffsetV), tTextImg.rect, [#ink: 36])
tTextImg = pWriterPlainNormRight.render(string(tParams[#teams][tTeamNum][#score]))
tImage.copyPixels(tTextImg, tTextImg.rect + rect(tOffsetH, tOffsetV, tOffsetH, tOffsetV), tTextImg.rect)
end if -- jump 268 landing
tTeamNum = 1 + tTeamNum
 -- backjump 684
end if -- jump 675 landing
tTeamNum = 1
if tTeamNum <= 4 then -- jump 89 -- backjump 92 landing
tElem = tWndObj.getElement("gs_link_team" & tTeamNum)
if tElem <> 0 then -- jump 59
if tTeamNum  = tOwnTeam or tParams[#state] <> #created then -- jump 16
tElem.setProperty(#visible, 0)
 -- jump 24
end if -- jump 16 landing
tElem.setProperty(#visible, 1)
tElem.feedImage(pJoinButtonImage)
end if -- jump 24 landing
end if -- jump 59 landing
tTeamNum = 1 + tTeamNum
 -- backjump 92
end if -- jump 89 landing
end

on renderPageNumber me, tPage, tNumPages
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tWndObj.getElement("gs_txt_pageNumber").setText(tPage & "/" & tNumPages)
tElem = tWndObj.getElement("gs_arrow_pageBack")
if tPage > 1 then -- jump 29
tElem.setProperty(#blend, 100)
tElem.setProperty(#cursor, "cursor.finger")
 -- jump 25
end if -- jump 29 landing
tElem.setProperty(#blend, 30)
tElem.setProperty(#cursor, 0)
end if -- jump 25 landing
tElem = tWndObj.getElement("gs_arrow_pageFwd")
if tPage < tNumPages then -- jump 29
tElem.setProperty(#blend, 100)
tElem.setProperty(#cursor, "cursor.finger")
 -- jump 25
end if -- jump 29 landing
tElem.setProperty(#blend, 30)
tElem.setProperty(#cursor, 0)
end if -- jump 25 landing
end

on updateRadioButton me, tElement, tListOfOthersElements
tOnImg = member(getmemnum("button.radio.on")).image
tOffImg = member(getmemnum("button.radio.off")).image
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tWndObj.elementExists(tElement) then -- jump 21
tWndObj.getElement(tElement).setProperty(#image, tOnImg)
end if -- jump 21 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tListOfOthersElements) <= 1 then -- jump 48 -- backjump 51 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tRadioElement = --nil--
if tWndObj.elementExists(tRadioElement) then -- jump 21
tWndObj.getElement(tRadioElement).setProperty(#image, tOffImg)
end if -- jump 21 landing
--nil-- + 1
 -- backjump 51
end if -- jump 48 landing
 --TRIMFROMSTACK 3 
end

on convertSecToMinSec me, tTime
tMin = tTime / 60
tSec = tTime mod 60
if tSec < 10 then -- jump 10
tSec = "0" & tSec
end if -- jump 10 landing
return(tMin & ":" & tSec)
end
