property pWindowState, pMainWindowId, pBalloonMargins, pWatchMode, pTournamentLogoMemNum, pTournamentLogoClickURL, pGameListPage, pGamesPerPage, pGameParameters, pRenderObj

on construct me
pBalloonMargins = [#normal: [:], #special: [:]]
pBalloonMargins[#normal][#left] = getIntVariable("balloons.leftmargin")
pBalloonMargins[#normal][#right] = getIntVariable("balloons.rightmargin")
pBalloonMargins[#special][#left] = 215
pBalloonMargins[#special][#right] = pBalloonMargins[#normal][#right]
pWindowState = 0
pWatchMode = 0
pMainWindowId = getText("sw_title")
pGameListPage = 1
pGamesPerPage = 6
pGameParameterStructFormat = []
pGameParameters = [:]
pRenderObj = createObject(#temp, "SnowwarLoungeMenu Renderer Class")
pRenderObj.defineWindow(pMainWindowId)
registerMessage(#alert, me.getID(), #delayedMenuToBack)
me.delayedMenuToBack()
return(1)
end

on deconstruct me
if objectp(pRenderObj) then -- jump 10
pRenderObj.deconstruct()
end if -- jump 10 landing
pRenderObj = void()
removeWindow(pMainWindowId)
me.setNormalBalloonMargins()
return(1)
end

on getWindowState me
return(pWindowState)
end

on setWindowState me, tstate
pWindowState = tstate
return(1)
end

on setNumTickets me
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_numtickets")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tGameSystemObj = me.getComponent().getGameSystem()
if tGameSystemObj  = 0 then -- jump 18
return(error(me, "Gamesystem not found.", #setNumTickets))
end if -- jump 18 landing
if tGameSystemObj.getGameTicketsNotUsedFlag() then -- jump 69
tElem.hide()
tElem = tWndObj.getElement("gs_amount_tickets_bg")
if tElem <> 0 then -- jump 10
tElem.hide()
end if -- jump 10 landing
tElem = tWndObj.getElement("gs_button_buytickets")
if tElem <> 0 then -- jump 10
tElem.hide()
end if -- jump 10 landing
return(1)
 -- jump 65
end if -- jump 69 landing
tNum = string(tGameSystemObj.getNumTickets())
if tNum.length  = 1 then -- jump 10
tNum = "00" & tNum
end if -- jump 10 landing
if tNum.length  = 2 then -- jump 10
tNum = "0" & tNum
end if -- jump 10 landing
return(tElem.setText(tNum))
end if -- jump 65 landing
end

on setTournamentLogo me, tdata
tMemNum = tdata[#member_num]
if tMemNum  = void() then -- jump 9
tMemNum = 0
 -- jump 20
end if -- jump 9 landing
pTournamentLogoMemNum = tMemNum
pTournamentLogoClickURL = tdata[#click_url]
end if -- jump 20 landing
if member(tMemNum).image.width > 100 then -- jump 21
return(pRenderObj.renderTournamentLogo(pTournamentLogoMemNum))
 -- jump 21
end if -- jump 21 landing
me.delay(500, #setTournamentLogo, tdata)
return()
end if -- jump 21 landing
end

on setInstanceList me
if me.getWindowState()  = 0 then -- jump 17
return(me.ChangeWindowView(#gameList))
end if -- jump 17 landing
if me.getWindowState() <> #gameList then -- jump 8
return(0)
end if -- jump 8 landing
return(me.showInstanceList())
end

on showInstanceList me
tGameSystemObj = me.getComponent().getGameSystem()
if tGameSystemObj  = 0 then -- jump 18
return(error(me, "Gamesystem not found.", #showInstanceList))
end if -- jump 18 landing
tList = tGameSystemObj.getInstanceList()
if not listp(tList) then -- jump 8
tList = [:]
end if -- jump 8 landing
tStartIndex = pGameListPage - 1 * pGamesPerPage + 1
pRenderObj.renderInstanceList(tList, tStartIndex, pGamesPerPage)
tNumPages = integer(tList.count - 1 / pGamesPerPage) + 1
if pGameListPage > tNumPages then -- jump 8
pGameListPage = 1
end if -- jump 8 landing
pRenderObj.renderPageNumber(pGameListPage, tNumPages)
end

on showInstance me
tGameSystemObj = me.getComponent().getGameSystem()
if tGameSystemObj  = 0 then -- jump 18
return(error(me, "Gamesystem not found.", #showInstance))
end if -- jump 18 landing
tParams = tGameSystemObj.getObservedInstance()
 --PEEKFROMSTACK 0 if tParams[#numTeams]  = 2 then -- jump 16
me.ChangeWindowView(#gameDetails2t)
 -- jump 55
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 3
if --nil-- then -- jump 16
me.ChangeWindowView(#gameDetails3t)
 -- jump 34
end if -- jump 16 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 16
me.ChangeWindowView(#gameDetails4t)
 -- jump 13
end if -- jump 16 landing
me.ChangeWindowView(#gameDetails1t)
end if -- jump 13 landing
end if -- jump 34 landing
end if -- jump 55 landing
 --TRIMFROMSTACK 1 
tStateStr = getText("gs_state_" & tParams[#state])
if tParams[#state]  = #created then -- jump 31
tSpecStr = replaceChunks(getText("gs_specnum"), "\x", tParams[#numSpectators])
 -- jump 7
end if -- jump 31 landing
tSpecStr = EMPTY
end if -- jump 7 landing
pRenderObj.renderInstanceDetailTop(tParams[#name], tParams[#host][#name], tParams[#state], tStateStr, tSpecStr)
tButtonState = me.getInstanceDetailButtonState(tParams[#state])
pRenderObj.renderInstanceDetailButton(tButtonState, tParams[#state])
tHost = me.getComponent().isUserHost()
tOwnTeam = me.getComponent().getUserTeamIndex()
pRenderObj.renderInstanceDetailTeams(tParams, me.getComponent().getUserName(), tHost, tOwnTeam)
return(1)
end

on showGameCreation me
me.ChangeWindowView(#createGame)
tWndObj = getWindow(pMainWindowId)
me.setGameCreationDefaults()
tElem = tWndObj.getElement("gs_field_gameNaming")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
updateStage()
me.setFieldType(1)
return(tElem.setFocus(1))
end

on ChangeWindowView me, tWindow
tWndObj = getWindow(pMainWindowId)
if tWndObj  = void() then -- jump 86
if me.getWindowState() <> 0 then -- jump 8
return(0)
end if -- jump 8 landing
if not createWindow(pMainWindowId) then -- jump 8
return(0)
end if -- jump 8 landing
tWndObj = getWindow(pMainWindowId)
tWndObj.moveTo(8, 8)
tWndObj.registerProcedure(#eventProcMainWindow, me.getID(), #mouseUp)
me.setSpecialBalloonMargins()
 -- jump 10
end if -- jump 86 landing
tWndObj.unmerge()
end if -- jump 10 landing
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
me.setWindowState(0)
 --PEEKFROMSTACK 0 if tWindow  = #gameList then -- jump 44
if not tWndObj.merge("sw_glist.window") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
me.showInstanceList()
pRenderObj.renderTournamentLogo(pTournamentLogoMemNum)
 -- jump 181
end if -- jump 44 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameDetails2t
if --nil-- then -- jump 26
if not tWndObj.merge("sw_ginfo2t.window") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
 -- jump 149
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameDetails3t
if --nil-- then -- jump 26
if not tWndObj.merge("sw_ginfo3t.window") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
 -- jump 117
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameDetails4t
if --nil-- then -- jump 26
if not tWndObj.merge("sw_ginfo4t.window") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
 -- jump 85
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = #gameDetails1t
if --nil-- then -- jump 26
if not tWndObj.merge("sw_ginfo1t.window") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
 -- jump 53
end if -- jump 26 landing
 --PEEKFROMSTACK 0 
--nil--  = #createGame
if --nil-- then -- jump 37
if not tWndObj.merge("sw_gcreate.window") then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
pRenderObj.renderTournamentLogo(pTournamentLogoMemNum)
 -- jump 10
end if -- jump 37 landing
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
end if -- jump 53 landing
end if -- jump 85 landing
end if -- jump 117 landing
end if -- jump 149 landing
end if -- jump 181 landing
 --TRIMFROMSTACK 1 
me.setNumTickets()
me.setWindowState(tWindow)
me.sendMenuToBack()
return(1)
end

on hideMainWindow me
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tWndObj.hide())
end

on eventProcMainWindow me, tEvent, tSprID, tParam
tGameSystemObj = me.getComponent().getGameSystem()
if tGameSystemObj  = 0 then -- jump 18
return(error(me, "Gamesystem not found.", #eventProcMainWindow))
end if -- jump 18 landing
 --PEEKFROMSTACK 0 if tSprID  = "gs_area_gameList1" then -- jump 41
tIndexOnPage = 1 + pGameListPage - 1 * pGamesPerPage
 --TRIMFROMSTACK 1 
return(me.getComponent().observeInstance(tIndexOnPage))
 -- jump 1466
end if -- jump 41 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_area_gameList2"
if --nil-- then -- jump 41
tIndexOnPage = 2 + pGameListPage - 1 * pGamesPerPage
 --TRIMFROMSTACK 1 
return(me.getComponent().observeInstance(tIndexOnPage))
 -- jump 1420
end if -- jump 41 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_area_gameList3"
if --nil-- then -- jump 41
tIndexOnPage = 3 + pGameListPage - 1 * pGamesPerPage
 --TRIMFROMSTACK 1 
return(me.getComponent().observeInstance(tIndexOnPage))
 -- jump 1374
end if -- jump 41 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_area_gameList4"
if --nil-- then -- jump 41
tIndexOnPage = 4 + pGameListPage - 1 * pGamesPerPage
 --TRIMFROMSTACK 1 
return(me.getComponent().observeInstance(tIndexOnPage))
 -- jump 1328
end if -- jump 41 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_area_gameList5"
if --nil-- then -- jump 41
tIndexOnPage = 5 + pGameListPage - 1 * pGamesPerPage
 --TRIMFROMSTACK 1 
return(me.getComponent().observeInstance(tIndexOnPage))
 -- jump 1282
end if -- jump 41 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_area_gameList6"
if --nil-- then -- jump 41
tIndexOnPage = 6 + pGameListPage - 1 * pGamesPerPage
 --TRIMFROMSTACK 1 
return(me.getComponent().observeInstance(tIndexOnPage))
 -- jump 1236
end if -- jump 41 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_arrow_pageFwd"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.changeInstanceListPage(1))
 -- jump 1210
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_arrow_pageBack"
if --nil-- then -- jump 22
 --TRIMFROMSTACK 1 
return(me.changeInstanceListPage(-1))
 -- jump 1183
end if -- jump 22 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_create"
if --nil-- then -- jump 19
 --TRIMFROMSTACK 1 
return(tGameSystemObj.initiateCreateGame())
 -- jump 1159
end if -- jump 19 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_gamelength_1"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setGameLength(1))
 -- jump 1133
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_gamelength_2"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setGameLength(2))
 -- jump 1107
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_gamelength_3"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setGameLength(3))
 -- jump 1081
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_2teams"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setNumberOfTeams(2))
 -- jump 1055
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_3teams"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setNumberOfTeams(3))
 -- jump 1029
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_4teams"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setNumberOfTeams(4))
 -- jump 1003
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_radio_1teams"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setNumberOfTeams(1))
 -- jump 977
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_dropmenu_gamefield"
if --nil-- then -- jump 21
 --TRIMFROMSTACK 1 
return(me.setFieldType(tParam))
 -- jump 951
end if -- jump 21 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_rdy"
if --nil-- then -- jump 124
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
if tWndObj.getElement("gs_field_gameNaming").getText()  = EMPTY then -- jump 18
 --TRIMFROMSTACK 1 
return(me.showErrorMessage("game_checkname"))
end if -- jump 18 landing
tText = tWndObj.getElement("gs_field_gameNaming").getText()
pGameParameters["name"] = convertSpecialChars(tText, 1)
me.hideMainWindow()
 --TRIMFROMSTACK 1 
return(tGameSystemObj.createGame(pGameParameters, 1))
 -- jump 822
end if -- jump 124 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_cncl"
if --nil-- then -- jump 53
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
me.ChangeWindowView(#gameList)
 --TRIMFROMSTACK 1 
return(tGameSystemObj.cancelCreateGame())
 -- jump 764
end if -- jump 53 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_leaveGame"
if --nil-- then -- jump 114
tParams = tGameSystemObj.getObservedInstance()
if tParams[#state]  = #created and me.getComponent().getUserTeamIndex() <> 0 or pWatchMode  = 1 then -- jump 29
pWatchMode = 0
me.getComponent().resetUserTeamIndex()
tGameSystemObj.leaveGame()
 -- jump 38
end if -- jump 29 landing
tGameSystemObj.unobserveInstance()
me.getComponent().resetUserTeamIndex()
 --TRIMFROMSTACK 1 
return(me.ChangeWindowView(#gameList))
end if -- jump 38 landing
 -- jump 645
end if -- jump 114 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_gameInfo"
if --nil-- then -- jump 104
tParams = tGameSystemObj.getObservedInstance()
tAction = me.getInstanceDetailButtonState(tParams[#state])
 --PEEKFROMSTACK 0 if tAction <> #start then -- jump 12
 --PEEKFROMSTACK 0 
--nil--  = #start_dimmed
if --nil-- then -- jump 19
end if -- jump 12 landing
 --TRIMFROMSTACK 2 
return(tGameSystemObj.startGame())
 -- jump 36
end if -- jump 19 landing
 --PEEKFROMSTACK 0 
--nil--  = #spectate
if --nil-- then -- jump 19
 --TRIMFROMSTACK 2 
return(tGameSystemObj.watchGame())
 -- jump 11
end if -- jump 19 landing
 --TRIMFROMSTACK 2 
return(1)
end if -- jump 11 landing
end if -- jump 36 landing
 --TRIMFROMSTACK 1 
 -- jump 536
end if -- jump 104 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_team1"
if --nil-- then -- jump 20
me.getComponent().joinGame(1)
 -- jump 511
end if -- jump 20 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_team2"
if --nil-- then -- jump 20
me.getComponent().joinGame(2)
 -- jump 486
end if -- jump 20 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_team3"
if --nil-- then -- jump 20
me.getComponent().joinGame(3)
 -- jump 461
end if -- jump 20 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_team4"
if --nil-- then -- jump 20
me.getComponent().joinGame(4)
 -- jump 436
end if -- jump 20 landing
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick1_1"
if --nil-- then -- jump 147
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick1_2"
if --nil-- then -- jump 139
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick1_3"
if --nil-- then -- jump 131
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick1_4"
if --nil-- then -- jump 123
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick1_5"
if --nil-- then -- jump 115
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick1_6"
if --nil-- then -- jump 107
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick2_1"
if --nil-- then -- jump 99
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick2_2"
if --nil-- then -- jump 91
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick2_3"
if --nil-- then -- jump 83
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick2_4"
if --nil-- then -- jump 75
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick2_5"
if --nil-- then -- jump 67
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick2_6"
if --nil-- then -- jump 59
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick3_1"
if --nil-- then -- jump 51
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick3_2"
if --nil-- then -- jump 43
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick3_3"
if --nil-- then -- jump 35
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick3_4"
if --nil-- then -- jump 27
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick4_1"
if --nil-- then -- jump 19
 --PEEKFROMSTACK 0 
--nil-- <> "bb_kick4_2"
if --nil-- then -- jump 11
 --PEEKFROMSTACK 0 
--nil--  = "bb_kick4_3"
if --nil-- then -- jump 161
end if -- jump 11 landing
end if -- jump 19 landing
end if -- jump 27 landing
end if -- jump 35 landing
end if -- jump 43 landing
end if -- jump 51 landing
end if -- jump 59 landing
end if -- jump 67 landing
end if -- jump 75 landing
end if -- jump 83 landing
end if -- jump 91 landing
end if -- jump 99 landing
end if -- jump 107 landing
end if -- jump 115 landing
end if -- jump 123 landing
end if -- jump 131 landing
end if -- jump 139 landing
end if -- jump 147 landing
tTeamNum = integer(string(tSprID).getProp(#char, 8))
tPlayerNum = integer(string(tSprID).getProp(#char, 10))
tdata = tGameSystemObj.getObservedInstance()
if tTeamNum < 1 or tTeamNum > tdata[#teams].count then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
tTeam = tdata[#teams][tTeamNum][#players]
if tPlayerNum < 1 or tPlayerNum > tTeam.count then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
 --TRIMFROMSTACK 1 
return(tGameSystemObj.kickPlayer(tTeam[tPlayerNum][#id]))
 -- jump 126
end if -- jump 161 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_gameRul"
if --nil-- then -- jump 18
openNetPage(getText("sw_link_gameRules_url"))
 -- jump 103
end if -- jump 18 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_highScr"
if --nil-- then -- jump 43
if tGameSystemObj.getTournamentFlag() then -- jump 18
openNetPage(getText("sw_link_tournament_highScores_url"))
 -- jump 15
end if -- jump 18 landing
openNetPage(getText("sw_link_highScores_url"))
end if -- jump 15 landing
 -- jump 55
end if -- jump 43 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_logo_tournament"
if --nil-- then -- jump 25
if pTournamentLogoClickURL <> void() then -- jump 11
openNetPage(pTournamentLogoClickURL)
end if -- jump 11 landing
 -- jump 25
end if -- jump 25 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_buytickets"
if --nil-- then -- jump 17
 --TRIMFROMSTACK 1 
return(executeMessage(#show_ticketWindow))
end if -- jump 17 landing
end if -- jump 25 landing
end if -- jump 55 landing
end if -- jump 103 landing
end if -- jump 126 landing
end if -- jump 436 landing
end if -- jump 461 landing
end if -- jump 486 landing
end if -- jump 511 landing
end if -- jump 536 landing
end if -- jump 645 landing
end if -- jump 764 landing
end if -- jump 822 landing
end if -- jump 951 landing
end if -- jump 977 landing
end if -- jump 1003 landing
end if -- jump 1029 landing
end if -- jump 1055 landing
end if -- jump 1081 landing
end if -- jump 1107 landing
end if -- jump 1133 landing
end if -- jump 1159 landing
end if -- jump 1183 landing
end if -- jump 1210 landing
end if -- jump 1236 landing
end if -- jump 1282 landing
end if -- jump 1328 landing
end if -- jump 1374 landing
end if -- jump 1420 landing
end if -- jump 1466 landing
 --TRIMFROMSTACK 1 
return(1)
end

on changeInstanceListPage me, tOffset
tGameSystemObj = me.getComponent().getGameSystem()
if tGameSystemObj  = 0 then -- jump 18
return(error(me, "Gamesystem not found.", #changeInstanceListPage))
end if -- jump 18 landing
tList = tGameSystemObj.getInstanceList()
if not listp(tList) then -- jump 8
return(0)
end if -- jump 8 landing
tNumPages = integer(tList.count - 1 / pGamesPerPage) + 1
if tOffset  = 1 then -- jump 32
if pGameListPage >= tNumPages then -- jump 11
return(0)
 -- jump 12
end if -- jump 11 landing
pGameListPage = pGameListPage + 1
end if -- jump 12 landing
 -- jump 38
end if -- jump 32 landing
if tOffset  = -1 then -- jump 29
if pGameListPage <= 1 then -- jump 11
return(0)
 -- jump 12
end if -- jump 11 landing
pGameListPage = pGameListPage - 1
end if -- jump 12 landing
end if -- jump 29 landing
end if -- jump 38 landing
return(me.showInstanceList())
end

on setGameCreationDefaults me
pGameParameters = [#new: 1]
tGameSystemObj = me.getComponent().getGameSystem()
if tGameSystemObj  = 0 then -- jump 18
return(error(me, "Gamesystem not found.", #setGameCreationDefaults))
end if -- jump 18 landing
tStruct = tGameSystemObj.getGameParameters()
if not listp(tStruct) then -- jump 18
return(error(me, "Invalid game parameters.", #setGameCreationDefaults))
end if -- jump 18 landing
tWndObj = getWindow(pMainWindowId)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tStruct) <= 1 then -- jump 166 -- backjump 169 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tItem = --nil--
pGameParameters.addProp(tItem[#name], tItem[#default])
 --PEEKFROMSTACK 0 if tItem[#name]  = "name" then -- jump 29
tWndObj.getElement("gs_field_gameNaming").setText(tItem[#default])
 -- jump 81
end if -- jump 29 landing
 --PEEKFROMSTACK 0 
--nil--  = "numTeams"
if --nil-- then -- jump 22
me.setNumberOfTeams(tItem[#default])
 -- jump 54
end if -- jump 22 landing
 --PEEKFROMSTACK 0 
--nil--  = "gameLengthChoice"
if --nil-- then -- jump 22
me.setGameLength(tItem[#default])
 -- jump 27
end if -- jump 22 landing
 --PEEKFROMSTACK 0 
--nil--  = "fieldType"
if --nil-- then -- jump 19
me.setFieldType(tItem[#default])
end if -- jump 19 landing
end if -- jump 27 landing
end if -- jump 54 landing
end if -- jump 81 landing
 --TRIMFROMSTACK 1 
--nil-- + 1
 -- backjump 169
end if -- jump 166 landing
 --TRIMFROMSTACK 3 
end

on setNumberOfTeams me, tValue
tOldElem = "gs_radio_" & pGameParameters["numTeams"] & "teams"
tNewElem = "gs_radio_" & tValue & "teams"
pGameParameters["numTeams"] = tValue
pRenderObj.updateRadioButton(EMPTY, [tOldElem])
pRenderObj.updateRadioButton(tNewElem, [])
return(1)
end

on setGameLength me, tValue
tOldElem = "gs_radio_gamelength_" & pGameParameters["gameLengthChoice"]
tNewElem = "gs_radio_gamelength_" & tValue
pGameParameters["gameLengthChoice"] = tValue
pRenderObj.updateRadioButton(EMPTY, [tOldElem])
pRenderObj.updateRadioButton(tNewElem, [])
return(1)
end

on setFieldType me, tValue
pGameParameters["fieldType"] = integer(tValue)
tWndObj = getWindow(pMainWindowId)
tDropDown = tWndObj.getElement("gs_dropmenu_gamefield")
if not ilk(tDropDown, #instance) then -- jump 21
return(error(me, "Unable to retrieve dropdown:" && tDropDown, #setFieldType))
end if -- jump 21 landing
tFieldTxtItems = []
tFieldKeyItems = []
i = 1
if i <= 7 then -- jump 44 -- backjump 47 landing
tFieldTxtItems[i] = getText("sw_fieldname_" & i)
tFieldKeyItems[i] = string(i)
i = 1 + i
 -- backjump 47
end if -- jump 44 landing
tDropDown.updateData(tFieldTxtItems, tFieldKeyItems, void(), tValue)
return(1)
end

on getInstanceDetailButtonState me, tGameState
tButton = #empty
if tGameState  = #created then -- jump 88
if me.getComponent().isUserHost() then -- jump 34
if me.getComponent().gameCanStart() then -- jump 11
tButton = #start
 -- jump 8
end if -- jump 11 landing
tButton = #start_dimmed
end if -- jump 8 landing
 -- jump 39
end if -- jump 34 landing
if pWatchMode then -- jump 11
tButton = #spectateInfo
 -- jump 25
end if -- jump 11 landing
if me.getComponent().getUserTeamIndex()  = 0 then -- jump 8
tButton = #spectate
end if -- jump 8 landing
end if -- jump 25 landing
end if -- jump 39 landing
 -- jump 34
end if -- jump 88 landing
if tGameState  = #started then -- jump 25
if me.getComponent().getUserTeamIndex()  = 0 then -- jump 8
tButton = #spectate
end if -- jump 8 landing
end if -- jump 25 landing
end if -- jump 34 landing
return(tButton)
end

on setWatchMode me, tBoolean
pWatchMode = tBoolean
end

on setSpecialBalloonMargins me
setVariable("balloons.leftmargin", pBalloonMargins[#special][#left])
setVariable("balloons.rightmargin", pBalloonMargins[#special][#right])
return(1)
end

on setNormalBalloonMargins me
setVariable("balloons.leftmargin", pBalloonMargins[#normal][#left])
setVariable("balloons.rightmargin", pBalloonMargins[#normal][#right])
return(1)
end

on showErrorMessage me, tErrorType, tRequestStr, tExtra
 --PEEKFROMSTACK 0 if tErrorType  = 2 then -- jump 22
executeMessage(#openOneClickGameBuyWindow)
 --TRIMFROMSTACK 1 
return(1)
 -- jump 64
end if -- jump 22 landing
 --PEEKFROMSTACK 0 
--nil--  = "game_deleted"
if --nil-- then -- jump 10
tAlertStr = "gs_error_game_deleted"
 -- jump 49
end if -- jump 10 landing
 --PEEKFROMSTACK 0 
--nil--  = "idlewarning"
if --nil-- then -- jump 10
tAlertStr = "gs_idlewarning"
 -- jump 34
end if -- jump 10 landing
tAlertStr = "gs_error_" & tRequestStr & "_" & tErrorType
if not textExists(tAlertStr) then -- jump 10
tAlertStr = "gs_error_" & tErrorType
end if -- jump 10 landing
end if -- jump 34 landing
end if -- jump 49 landing
end if -- jump 64 landing
 --TRIMFROMSTACK 1 
 --PEEKFROMSTACK 0 if tRequestStr  = "create" then -- jump 13
me.ChangeWindowView(#gameList)
end if -- jump 13 landing
 --TRIMFROMSTACK 1 
 --PEEKFROMSTACK 0 if tErrorType  = 6 then -- jump 13
me.ChangeWindowView(#gameList)
end if -- jump 13 landing
 --TRIMFROMSTACK 1 
return(executeMessage(#alert, [#id: "gs_error", #Msg: tAlertStr]))
end

on delayedMenuToBack me
createTimeout(#temp, 3000, #sendMenuToBack, me.getID(), void(), 1)
end

on sendMenuToBack me
if not windowExists(pMainWindowId) then -- jump 8
return(0)
end if -- jump 8 landing
tWndObj = getWindow(pMainWindowId)
tWndObj.moveZ(-100000)
tWndObj.lock()
end
