property pWindowID, pTimeOutID, pOpenWindow, pScoreData, pPlayerData, pCountdownEndTime, pJoinedPlayers, pBestPlayer, pWriterPlainNormLeft, pWriterPlainBoldLeft, pWriterLinkRight

on construct me
pScoreData = [:]
pPlayerData = [:]
pJoinedPlayers = [:]
pBestPlayer = [:]
pWindowID = getText("gs_title_finalscores")
pTimeOutID = "gs_endgame_resetGameTimeout"
createWriter("gs_plain_norm_left", getStructVariable("struct.font.plain"))
pWriterPlainNormLeft = getWriter("gs_plain_norm_left")
pWriterPlainNormLeft.define([#wordWrap: 0, #fixedLineSpace: 16])
createWriter("gs_plain_bold_left", getStructVariable("struct.font.bold"))
pWriterPlainBoldLeft = getWriter("gs_plain_bold_left")
createWriter("gs_link_right", getStructVariable("struct.font.link"))
pWriterLinkRight = getWriter("gs_link_right")
pWriterLinkRight.setProperty(#alignment, #right)
registerMessage(#remove_user, me.getID(), #showRemovedPlayer)
return(1)
end

on deconstruct me
me.removeFinalScores()
removeWriter("gs_plain_norm_left")
pWriterPlainNormLeft = void()
removeWriter("gs_plain_bold_left")
pWriterPlainBoldLeft = void()
removeWriter("gs_link_right")
pWriterLinkRight = void()
pBestPlayer = void()
unregisterMessage(#remove_user, me.getID())
return(1)
end

on Refresh me, tTopic, tdata
 --PEEKFROMSTACK 0 if tTopic  = #gameend then -- jump 44
pJoinedPlayers = [:]
me.saveSortedScores(tdata)
me.startResetCountdown(tdata[#time_until_game_reset])
me.toggleWindowMode()
 -- jump 65
end if -- jump 44 landing
 --PEEKFROMSTACK 0 
--nil--  = #gamereset
if --nil-- then -- jump 13
me.removeFinalScores()
 -- jump 46
end if -- jump 13 landing
 --PEEKFROMSTACK 0 
--nil--  = #playerrejoined
if --nil-- then -- jump 15
me.showJoinedPlayer(tdata)
 -- jump 25
end if -- jump 15 landing
 --PEEKFROMSTACK 0 
--nil--  = #numtickets
if --nil-- then -- jump 16
 --TRIMFROMSTACK 1 
return(me.renderNumTickets())
end if -- jump 16 landing
end if -- jump 25 landing
end if -- jump 46 landing
end if -- jump 65 landing
 --TRIMFROMSTACK 1 
return(1)
end

on toggleWindowMode me
if pOpenWindow  = void() or pOpenWindow  = "sw_score_tiny.window" then -- jump 133
if not listp(pScoreData) then -- jump 8
return(0)
end if -- jump 8 landing
tTeamNum = pScoreData.count
pOpenWindow = "sw_score_big_" & tTeamNum & "t.window"
if not createWindow(pWindowID, pOpenWindow) then -- jump 18
return(error(me, "Cannot open score window.", #toggleWindowMode))
end if -- jump 18 landing
me.renderFinalScoresText()
me.showJoinedPlayers()
tWndObj = getWindow(pWindowID)
if me.getGameSystem().getSpectatorModeFlag() then -- jump 17
tWndObj.moveTo(124, 74)
 -- jump 14
end if -- jump 17 landing
tWndObj.moveTo(124, 50)
end if -- jump 14 landing
 -- jump 86
end if -- jump 133 landing
pOpenWindow = "sw_score_tiny.window"
if not createWindow(pWindowID, pOpenWindow) then -- jump 18
return(error(me, "Cannot open score window.", #toggleWindowMode))
end if -- jump 18 landing
tWndObj = getWindow(pWindowID)
if me.getGameSystem().getSpectatorModeFlag() then -- jump 17
tWndObj.moveTo(41, 50)
 -- jump 14
end if -- jump 17 landing
tWndObj.moveTo(25, 26)
end if -- jump 14 landing
end if -- jump 86 landing
tWndObj.center()
tWndObj.lock()
tWndObj.registerProcedure(#eventProc, me.getID(), #mouseUp)
me.showJoinedPlayersNum()
me.renderCountdownTimer()
me.renderNumTickets()
return(1)
end

on removeFinalScores me
pCountdownEndTime = void()
pOpenWindow = void()
if windowExists(pWindowID) then -- jump 11
removeWindow(pWindowID)
end if -- jump 11 landing
if timeoutExists(pTimeOutID) then -- jump 11
removeTimeout(pTimeOutID)
end if -- jump 11 landing
return(1)
end

on renderNumTickets me
tWndObj = getWindow(pWindowID)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_numtickets")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if me.getGameSystem()  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if me.getGameSystem().getGameTicketsNotUsedFlag() then -- jump 63
tElem.hide()
tElem = tWndObj.getElement("gs_amount_tickets_bg")
if tElem <> 0 then -- jump 10
tElem.hide()
end if -- jump 10 landing
tElem = tWndObj.getElement("gs_button_buytickets")
if tElem <> 0 then -- jump 10
tElem.hide()
end if -- jump 10 landing
 -- jump 65
end if -- jump 63 landing
tNumTickets = string(me.getGameSystem().getNumTickets())
if tNumTickets.length  = 1 then -- jump 10
tNumTickets = "00" & tNumTickets
end if -- jump 10 landing
if tNumTickets.length  = 2 then -- jump 10
tNumTickets = "0" & tNumTickets
end if -- jump 10 landing
tElem.setText(tNumTickets)
end if -- jump 65 landing
return(1)
end

on saveSortedScores me, tdata
pScoreData = tdata[#gameend_scores]
tSortedTeams = []
tTeamNum = pScoreData.count
tTeamId = 1
if tTeamId <= tTeamNum then -- jump 258 -- backjump 260 landing
tdata = pScoreData[tTeamId]
tSortedPlayers = []
tPlayerNum = 1
if tPlayerNum <= tdata[#players].count then -- jump 116 -- backjump 128 landing
tPos = 1
if tSortedPlayers.count > 0 then -- jump 66
if tSortedPlayers[tPos][#score] > tdata[#players][tPlayerNum][#score] then -- jump 25 -- backjump 61 landing
tPos = tPos + 1
if tPos > tSortedPlayers.count then -- jump 6
 -- jump 5
end if -- jump 6 landing
 -- backjump 61
end if -- jump 5 landing
end if -- jump 25 landing
end if -- jump 66 landing
tSortedPlayers.addAt(tPos, tdata[#players][tPlayerNum].duplicate())
tPlayerNum = 1 + tPlayerNum
 -- backjump 128
end if -- jump 116 landing
tPos = 1
if tSortedTeams.count > 0 then -- jump 53
if tSortedTeams[tPos][#score] > tdata[#score] then -- jump 25 -- backjump 48 landing
tPos = tPos + 1
if tPos > tSortedTeams.count then -- jump 6
 -- jump 5
end if -- jump 6 landing
 -- backjump 48
end if -- jump 5 landing
end if -- jump 25 landing
end if -- jump 53 landing
tSortedTeams.addAt(tPos, [#score: tdata[#score], #team_id: tTeamId, #players: tSortedPlayers])
tTeamId = 1 + tTeamId
 -- backjump 260
end if -- jump 258 landing
pScoreData = tSortedTeams
if getObject(#session).exists("user_game_index") then -- jump 17
tOwnId = getObject(#session).GET("user_game_index")
end if -- jump 17 landing
tOwnPlayerWins = 0
pPlayerData = [:]
pBestPlayer = [:]
tTeamInfoCount = 1
if tTeamInfoCount <= tTeamNum then -- jump 288 -- backjump 290 landing
tdata = pScoreData[tTeamInfoCount]
tPlayerNum = 1
if tPlayerNum <= tdata[#players].count then -- jump 246 -- backjump 257 landing
tPlayerId = string(tdata[#players][tPlayerNum][#id])
tPlayerName = tdata[#players][tPlayerNum][#name]
pPlayerData.addProp(tPlayerId, tPlayerName)
if tPlayerId  = tOwnId and tTeamInfoCount  = 1 then -- jump 7
tOwnPlayerWins = 1
end if -- jump 7 landing
if tdata[#players][tPlayerNum][#score] > pBestPlayer[#score] then -- jump 72
pBestPlayer[#tie] = 0
pBestPlayer[#id] = tPlayerId
pBestPlayer[#name] = tPlayerName
pBestPlayer[#score] = tdata[#players][tPlayerNum][#score]
 -- jump 51
end if -- jump 72 landing
if tdata[#players][tPlayerNum][#score]  = pBestPlayer[#score] then -- jump 15
pBestPlayer[#tie] = 1
end if -- jump 15 landing
end if -- jump 51 landing
tPlayerNum = 1 + tPlayerNum
 -- backjump 257
end if -- jump 246 landing
tTeamInfoCount = 1 + tTeamInfoCount
 -- backjump 290
end if -- jump 288 landing
if pBestPlayer[#tie] then -- jump 12
playSound("LS-C64-win-1")
 -- jump 48
end if -- jump 12 landing
pBestPlayer[#image] = me.getBestPlayerImage(pBestPlayer[#id])
if tOwnPlayerWins then -- jump 12
playSound("LS-C64-win-1")
 -- jump 9
end if -- jump 12 landing
playSound("LS-C64-loose-1")
end if -- jump 9 landing
end if -- jump 48 landing
return(1)
end

on renderFinalScoresText me
tWndObj = getWindow(pWindowID)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if me.getGameSystem().getSpectatorModeFlag() then -- jump 57
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(["gs_button_rejoin", "gs_button_leaveGame2"]) <= 1 then -- jump 32 -- backjump 35 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tButtonID = --nil--
tWndObj.getElement(tButtonID).hide()
--nil-- + 1
 -- backjump 35
end if -- jump 32 landing
 --TRIMFROMSTACK 3 
end if -- jump 57 landing
tTeamNum = pScoreData.count
tTeamInfoCount = 1
if tTeamInfoCount <= tTeamNum then -- jump 166 -- backjump 169 landing
tdata = pScoreData[tTeamInfoCount]
tTeamId = tdata[#team_id]
tElem = tWndObj.getElement("gs_scores_icon_team" & tTeamInfoCount)
tImage = member(getmemnum("sw_ico_team" & tTeamId)).image
if tElem <> 0 and tImage <> void() then -- jump 12
tElem.feedImage(tImage)
end if -- jump 12 landing
tElem = tWndObj.getElement("gs_scores_score_team" & tTeamInfoCount)
if tElem <> 0 then -- jump 19
tElem.setText(tdata[#score])
end if -- jump 19 landing
tImage = me.renderFinalScoreItem(tdata)
tElem = tWndObj.getElement("bb_area_scores" & tTeamInfoCount)
if tImage <> 0 then -- jump 12
tElem.feedImage(tImage)
end if -- jump 12 landing
tTeamInfoCount = 1 + tTeamInfoCount
 -- backjump 169
end if -- jump 166 landing
if not pBestPlayer[#tie] then -- jump 151
if pBestPlayer[#image]  = void() then -- jump 24
pBestPlayer[#image] = member(getmemnum("guide_tie")).image
end if -- jump 24 landing
tElem = tWndObj.getElement("gs_bestplayer_name")
tElem.setText(pBestPlayer[#name])
tElem = tWndObj.getElement("gs_bestplayer_score")
tElem.setText(pBestPlayer[#score])
tElem = tWndObj.getElement("bb_icon_winner")
if tElem <> 0 and ilk(pBestPlayer[#image])  = #image then -- jump 19
tElem.feedImage(pBestPlayer[#image])
end if -- jump 19 landing
 -- jump 86
end if -- jump 151 landing
tPlayerImage = member(getmemnum("guide_tie")).image
tElem = tWndObj.getElement("bb_icon_winner")
if tElem <> 0 and ilk(tPlayerImage)  = #image then -- jump 12
tElem.feedImage(tPlayerImage)
end if -- jump 12 landing
tElem = tWndObj.getElement("gs_bestplayer_title")
if tElem <> 0 then -- jump 17
tElem.setText(getText("gs_score_tie"))
end if -- jump 17 landing
end if -- jump 86 landing
return(1)
end

on renderFinalScoreItem me, tTeam
tNameTxt = EMPTY
tScoreTxt = EMPTY
tImage = image(165, tTeam[#players].count * 16, 32)
tPlayerNum = 1
if tPlayerNum <= tTeam[#players].count then -- jump 72 -- backjump 84 landing
tScoreTxt = tScoreTxt & tTeam[#players][tPlayerNum][#score] & RETURN
tNameTxt = tNameTxt & tTeam[#players][tPlayerNum][#name] & RETURN
tPlayerNum = 1 + tPlayerNum
 -- backjump 84
end if -- jump 72 landing
tOffset = 0
tNameImage = pWriterPlainNormLeft.render(tNameTxt)
tImage.copyPixels(tNameImage, tNameImage.rect + rect(6, -5 + tOffset, 6, -5 + tOffset), tNameImage.rect)
tScoreImage = pWriterPlainNormLeft.render(tScoreTxt)
tImage.copyPixels(tScoreImage, tScoreImage.rect + rect(130, -5 + tOffset, 130, -5 + tOffset), tScoreImage.rect)
return(tImage)
end

on showJoinedPlayer me, tdata
tStrId = string(tdata[#id])
tHumanId = string(me.getGameSystem().getGameObjectProperty(tStrId, "human_id"))
tRoomIndex = string(me.getGameSystem().getGameObjectProperty(tStrId, "room_index"))
if pJoinedPlayers.findPos(tRoomIndex)  = 0 then -- jump 19
pJoinedPlayers.addProp(tRoomIndex, ["human_id": tHumanId])
end if -- jump 19 landing
me.showPlayerIcon(#joined, [#id: tHumanId])
me.showJoinedPlayersNum()
return(1)
end

on showRemovedPlayer me, tRoomIndex
if pJoinedPlayers.findPos(tRoomIndex)  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tHumanId = pJoinedPlayers[tRoomIndex]["human_id"]
pJoinedPlayers.deleteProp(tRoomIndex)
me.showPlayerIcon(0, [#id: tHumanId])
me.showJoinedPlayersNum()
return(1)
end

on showPlayerIcon me, tIcon, tdata
tWndObj = getWindow(pWindowID)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tStrId = string(tdata[#id])
if pScoreData  = void() then -- jump 8
return(0)
end if -- jump 8 landing
tTeamNum = 1
if tTeamNum <= pScoreData.count then -- jump 97 -- backjump 103 landing
tPlayerNum = 1
if tPlayerNum <= pScoreData[tTeamNum][#players].count then -- jump 60 -- backjump 79 landing
if pScoreData[tTeamNum][#players][tPlayerNum][#id]  = tdata[#id] then -- jump 11
tMyTeamNum = tTeamNum
tMyPlayerNum = tPlayerNum
end if -- jump 11 landing
tPlayerNum = 1 + tPlayerNum
 -- backjump 79
end if -- jump 60 landing
tTeamNum = 1 + tTeamNum
 -- backjump 103
end if -- jump 97 landing
tElem = tWndObj.getElement("bb_area_scores" & tMyTeamNum)
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tImage = tElem.getProperty(#image)
if tIcon  = #joined then -- jump 20
tStarImg = member(getmemnum("sw_ico_star_lt")).image
 -- jump 15
end if -- jump 20 landing
tStarImg = image(11, 9, 8)
end if -- jump 15 landing
tImage.copyPixels(tStarImg, tStarImg.rect + rect(109, 1 + 16 * tMyPlayerNum - 1, 109, 1 + 16 * tMyPlayerNum - 1), tStarImg.rect)
tElem.feedImage(tImage)
return(1)
end

on showJoinedPlayers me
if not listp(pJoinedPlayers) then -- jump 9
return(1)
end if -- jump 9 landing
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pJoinedPlayers) <= 1 then -- jump 49 -- backjump 52 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tPlayer = --nil--
tHumanId = string(tPlayer["human_id"])
me.showPlayerIcon(#joined, [#id: tHumanId])
--nil-- + 1
 -- backjump 52
end if -- jump 49 landing
 --TRIMFROMSTACK 3 
return(1)
end

on showJoinedPlayersNum me
tWndObj = getWindow(pWindowID)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_joinedplayers")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
return(tElem.setText(replaceChunks(getText("gs_joinedplayers"), "\x", pJoinedPlayers.count)))
end

on startResetCountdown me, tSecondsLeft
if tSecondsLeft <= 0 then -- jump 8
return(0)
end if -- jump 8 landing
pCountdownEndTime = the milliSeconds + tSecondsLeft * 1000
if timeoutExists(pTimeOutID) then -- jump 11
removeTimeout(pTimeOutID)
end if -- jump 11 landing
createTimeout(pTimeOutID, 1000, #renderCountdownTimer, me.getID(), pCountdownEndTime, tSecondsLeft)
me.renderCountdownTimer()
return(1)
end

on convertToMinSec me, tTime
tMin = tTime / 60000
tSec = tTime mod 60000 / 1000
if tSec < 10 then -- jump 10
tSec = "0" & tSec
end if -- jump 10 landing
return([tMin, tSec])
end

on renderCountdownTimer me
if pCountdownEndTime  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tEndTime = pCountdownEndTime
tWndObj = getWindow(pWindowID)
if tWndObj  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tElem = tWndObj.getElement("gs_timetojoin")
if tElem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
if tEndTime < the milliSeconds then -- jump 8
return(0)
end if -- jump 8 landing
tTime = me.convertToMinSec(tEndTime - the milliSeconds)
tTimeStr = tTime[1] & ":" & tTime[2]
tElem.setText(replaceChunks(getText("gs_timetojoin"), "\x", tTimeStr))
end

on getBestPlayerImage me, tUserID
tUserGameObj = me.getGameSystem().getGameObject(string(tUserID))
if tUserGameObj  = 0 then -- jump 21
return(error(me, "Winning player's userobject not found in room, id:" && tUserID, #getBestPlayerImage))
end if -- jump 21 landing
tTempImage = tUserGameObj.getRoomObjectImage()
tPlayerImage = image(tTempImage.width, tTempImage.height, 32)
tPlayerImage.copyPixels(tTempImage, tTempImage.rect, tTempImage.rect + rect(27, 45, 27, 45))
return(tPlayerImage)
end

on eventProc me, tEvent, tSprID, tParam
 --PEEKFROMSTACK 0 if tSprID  = "gs_button_rejoin" then -- jump 35
if me.getGameSystem()  = 0 then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
me.getGameSystem().rejoinGame()
 -- jump 105
end if -- jump 35 landing
 --PEEKFROMSTACK 0 
--nil-- <> "gs_button_leavegame"
if --nil-- then -- jump 11
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_leaveGame2"
if --nil-- then -- jump 35
end if -- jump 11 landing
if me.getGameSystem()  = 0 then -- jump 10
 --TRIMFROMSTACK 1 
return(0)
end if -- jump 10 landing
me.getGameSystem().enterLounge()
 -- jump 57
end if -- jump 35 landing
 --PEEKFROMSTACK 0 
--nil-- <> "gs_link_shrink"
if --nil-- then -- jump 11
 --PEEKFROMSTACK 0 
--nil--  = "gs_link_expand"
if --nil-- then -- jump 19
end if -- jump 11 landing
 --TRIMFROMSTACK 1 
return(me.toggleWindowMode())
 -- jump 25
end if -- jump 19 landing
 --PEEKFROMSTACK 0 
--nil--  = "gs_button_buytickets"
if --nil-- then -- jump 17
 --TRIMFROMSTACK 1 
return(executeMessage(#show_ticketWindow))
end if -- jump 17 landing
end if -- jump 25 landing
end if -- jump 57 landing
end if -- jump 105 landing
 --TRIMFROMSTACK 1 
end
